/*
 * simple_mutex.c
 * Simple multi-threaded example using mutex 
 * to protect shared data.
 */
#ifdef SUN
#include "../pthread_sol2.7.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>

void do_thread_1(int *);
void do_thread_2(int *);
void do_wrap_up(int, int);

int r1 = 0, r2 = 0, r3 = 0, g1 = 0;

pthread_mutex_t r3_mutex;

int main(int argc, char **argv)
{ pthread_t       thread1, thread2;

  pthread_mutex_init(&r3_mutex, NULL);
  if (argc < 2)  {
	printf("usage %s number\n", argv[0]); 
        exit(1);  
  }
  r3 = atoi(argv[1]);
  pthread_create(&thread1, NULL, (void *) do_thread_1, (void *) &r1); 
  pthread_create(&thread2, NULL, (void *) do_thread_2, (void *) &r2); 
  pthread_join(thread1, NULL);
  printf("main: 1.Thread fertig\n");
  pthread_join(thread2, NULL);
  printf("main: 2.Thread fertig\n");
  do_wrap_up(r1, r2);
}

void do_thread_1(int *pnum_times)
{ int  i,x;
  static int v2;
  int lr3;
 
  for (i = 0;  i < 4; i++) {
    printf("%d: do_thread_1: vor mutex_lock\n",getpid());
    pthread_mutex_lock(&r3_mutex);
    printf("%d: do_thread_1: r3=%d,x=%d\n",getpid(),lr3,x);
    sleep(3);
    g1++; v2++; 
    printf("%d: do_thread_1: g1=%d,v2=%d\n",getpid(),g1,v2);
    pthread_mutex_unlock(&r3_mutex); 
    printf("%d: do_thread_1: nach mutex_lock\n",getpid());
    (*pnum_times)++;
    /* sleep(1);*/ 
  }
  pthread_exit(NULL);
}

void do_thread_2(int *pnum_times)
{ int i,x;
  static int v2;
  int lr3;
 
  for (i = 0;  i < 4; i++) {
    printf("%d: do_thread_2: vor mutex_lock\n",getpid());
    pthread_mutex_lock(&r3_mutex);
    printf("%d: do_thread_2: r3=%d,x=%d\n",getpid(),lr3,x);
    sleep(1);
    g1++; v2++; 
    printf("%d: do_thread_2: g1=%d,v2=%d\n",getpid(),g1,v2);
    pthread_mutex_unlock(&r3_mutex); 
    printf("%d: do_thread_2: nach mutex_lock\n",getpid());
    (*pnum_times)++;
  }
  pthread_exit(NULL);
}

void do_wrap_up(int one_times, int another_times)
{ int total;

  total = one_times + another_times;
  printf("All done, one thing %d, another %d for a total of %d\n",
	one_times, another_times, total);
}
